//Datei: BIN2BCD.C
// Wandelt eine 24 Bit Binrzahl
// in 4 BCD Bytes=>8 Stellen
//
// Nach dem Beispiel von Microchip CD
// Benutzen, nur nicht drber nachdenken !
//
// War auf 16Bit Wert ausgelegt !
// Erweitert auf 24Bit, d.h. bis 16777216 !
// 
// Holger Klabunde
// 19.05.1999
// Compiler ByteCraft MPC V1.3

#include "prozess.h"      /* Der verwendete Prozessor */
#include "protos.h"

//Input : 24 Bit Wert in B0=LSB,B1,B2=MSB
//Output: 8 Bit Globale Register  R0,R1,R2,R3
//        R0 = MSB, R3 = LSB
unsigned char B0,B1,B2;
unsigned char R0,R1,R2,R3;

void BinToBCD24()
{
 unsigned char counter,temp;
 
#asm
B2_BCD  bcf STATUS,0   // clear the carry bit
	movlw 0x18     //24 Bits bearbeiten
	movwf counter  //Schleifenzhler
	clrf R0        //R0,R1,R2,R3=0
	clrf R1
	clrf R2
	clrf R3
loop24  rlf B0     //Rotiere Bitweise mit R3,R2,R1,R0
	rlf B1
	rlf B2
	rlf R3
	rlf R2
	rlf R1
	rlf R0
	decfsz counter  //Nchstes Bit
	goto adjDEC
	RETLW 0

adjDEC  movlw R3        //Zeiger auf R3
	movwf FSR       
	call adjBCD     //BCD-Korrektur
	movlw R2        //Auch fr R2,R1,R0
	movwf FSR
	call adjBCD
	movlw R1       
	movwf FSR
	call adjBCD
	movlw R0
	movwf FSR
	call adjBCD
	goto loop24     //Nchstes von den 24 Bits

	//Register 0 zeigt auf R3,R2,R1 oder R0
adjBCD  movlw 0x03     //Untere BCD-Stelle testen
	addwf 0,W      //0x03 addieren zu R0,R1,R2 oder R3
	movwf temp     //zwischenspeichern fr Test Bit D3
	btfsc temp,3   
	movwf 0        

	movlw 0x30     //Das gleiche mit der oberen BCD-Stelle
	addwf 0,W
	movwf temp
	btfsc temp,7   
	movwf 0        
	RETLW 0        // Ergebnis in R0,R1,R2,R3 zurckgeben
#endasm
}

//{Zeigt ein BCD-Byte auf der LCD-Anzeige }
//
void ShowBCD(unsigned char x)
{
 //ASCII Zahlen beginnen bei 0x30 => 0
 LCDWriteByte((x>>4)+0x30);  //High-Nibble
 LCDWriteByte((x&0x0F)+0x30);  //Low-Nibble
}

